#ifndef _H_CMODULE
#define _H_CMODULE

class CModule;

#include "CBot.h"

class CModule {
public:

  CModule (CBot *);
  ~CModule (void);

  bool init (const char *);

  char filename[FILE_SIZE+1];		// path, as provided to init()

  void *handle;				// handle returned by dlopen()

  struct module_type {
    u_char version;				// module version
    const char *name;				// module name
    void (*start) (CModule *);		// executed when loading the module
    void (*stop) (CModule *);		// executed when unloading the module
    void (*conf) (CServer *, const char *);	// configuration parser
    void (*set) (CServer *, const char *, char *, size_t);// !set handler
  };
  struct module_type *module;

  CBot *b;					// bot to which belongs

};

#endif
